.\" Copyright (c) 1993, 1994  X Consortium
.\" 
.\" Permission is hereby granted, free of charge, to any person obtaining a
.\" copy of this software and associated documentation files (the "Software"), 
.\" to deal in the Software without restriction, including without limitation 
.\" the rights to use, copy, modify, merge, publish, distribute, sublicense, 
.\" and/or sell copies of the Software, and to permit persons to whom the 
.\" Software furnished to do so, subject to the following conditions:
.\" 
.\" The above copyright notice and this permission notice shall be included in
.\" all copies or substantial portions of the Software.
.\" 
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
.\" IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
.\" FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL 
.\" THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
.\" WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF 
.\" OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
.\" SOFTWARE.
.\" 
.\" Except as contained in this notice, the name of the X Consortium shall not 
.\" be used in advertising or otherwise to promote the sale, use or other 
.\" dealing in this Software without prior written authorization from the 
.\" X Consortium.
.\"
.ds tk X Toolkit
.ds xT X Toolkit Intrinsics \- C Language Interface
.ds xI Intrinsics
.ds xW X Toolkit Athena Widgets \- C Language Interface
.ds xL Xlib \- C Language X Interface
.ds xC Inter-Client Communication Conventions Manual
.ds Rn 3
.ds Vn 2.2
.hw XtAdd-Event-Handler XtAdd-Raw-Event-Handler XtRemove-Event-Handler XtRemove-Raw-Event-Handler XtInsert-Event-Handler XtInsert-Raw-Event-Handler wid-get
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de ZN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH XtAddEventHandler __libmansuffix__ __xorgversion__ "XT FUNCTIONS"
.SH NAME
XtAddEventHandler, XtAddRawEventHandler, XtRemoveEventHandler, XtRemoveRawEventHandler, XtInsertEventHandler, XtInsertRawEventHandler \- add and remove event handlers
.SH SYNTAX
.HP
void XtAddEventHandler(Widget \fIw\fP, EventMask \fIevent_mask\fP, Boolean
\fInonmaskable\fP, XtEventHandler \fIproc\fP, XtPointer \fIclient_data\fP); 
.HP
void XtAddRawEventHandler(Widget \fIw\fP, EventMask \fIevent_mask\fP, Boolean
\fInonmaskable\fP, XtEventHandler \fIproc\fP, XtPointer \fIclient_data\fP); 
.HP
void XtRemoveEventHandler(Widget \fIw\fP, EventMask \fIevent_mask\fP, Boolean
\fInonmaskable\fP, XtEventHandler \fIproc\fP, XtPointer \fIclient_data\fP); 
.HP
void XtRemoveRawEventHandler(Widget \fIw\fP, EventMask \fIevent_mask\fP,
Boolean \fInonmaskable\fP, XtEventHandler \fIproc\fP, XtPointer
\fIclient_data\fP); 
.HP
void XtInsertEventHandler(Widget \fIw\fP, EventMask \fIevent_mask\fP, Boolean
\fInonmaskable\fP, XtEventHandler \fIproc\fP, XtPointer \fIclient_data\fP,
XtListPosition \fIposition\fP); 
.HP
void XtInsertRawEventHandler(Widget \fIw\fP, EventMask \fIevent_mask\fP,
Boolean \fInonmaskable\fP, XtEventHandler \fIproc\fP, XtPointer
\fIclient_data\fP, XtListPosition \fIposition\fP); 
.HP
typedef enum { XtListHead, XtListTail } XtListPosition;
.SH ARGUMENTS
.IP \fIclient_data\fP 1i
Specifies additional data to be passed to the client's event handler.
.ds Em to call or unregister this procedure
.IP \fIevent_mask\fP 1i
Specifies the event mask for which \*(Em.
.ds Nm called or removed
.IP \fInonmaskable\fP 1i
Specifies a Boolean value that indicates whether this procedure should be 
\*(Nm on the nonmaskable events
.Pn ( GraphicsExpose ,
.ZN NoExpose ,
.ZN SelectionClear ,
.ZN SelectionRequest ,
.ZN SelectionNotify ,
.ZN ClientMessage ,
and
.ZN MappingNotify ).
.ds Pr \ to be added or removed
.IP \fIproc\fP 1i
Specifies the procedure that is\*(Pr.
.ds Wi for which this event handler is being registered
.IP \fIw\fP 1i
Specifies the widget \*(Wi.
.IP \fIposition\fP 1i
Specifies when the event handler is to be called relative to other
previously registered handlers.
.SH DESCRIPTION
The
.ZN XtAddEventHandler
function registers a procedure with the dispatch mechanism that is
to be called when an event that matches the mask occurs on the specified
widget.
If the procedure is already registered with the same client_data,
the specified mask is ORed into the existing mask.
If the widget is realized,
.ZN XtAddEventHandler
calls
.ZN XSelectInput ,
if necessary.
.LP
The
.ZN XtAddRawEventHandler
function is similar to
.ZN XtAddEventHandler 
except that it does not affect the widget's mask and never causes an
.ZN XSelectInput
for its events.
Note that the widget might already have those mask bits set
because of other nonraw event handlers registered on it.
.LP
The
.ZN XtRemoveRawEventHandler
function stops the specified procedure from receiving the specified events.
Because the procedure is a raw event handler,
this does not affect the widget's mask and never causes a call on
.ZN XSelectInput .
.LP
.ZN XtInsertEventHandler
is identical to
.ZN XtAddEventHandler
with the additional \fIposition\fP argument. if \fIposition\fP is
.ZN XtListHead ,
the event handler is registered to that it will be called before
any event handlers that were previously registered for the same widget.
If \fIposition\fP is
.ZN XtListTail ,
the event handler is registered to be called after any previously
registered event handlers. If the procedure is already registered with
the same \fIclient_data\fP value, the specified mask augments the
existing mask and the procedure is repositioned in the list.
.LP
.ZN XtInsertRawEventHandler
is similar to
.ZN XtInsertEventHandler
except that it does not modify the widget's event mask and never causes an
.ZN XSelectInput
for the specified events. If the procedure is already registered with the
same \fIclient_data\fP value, the specified mask augments the existing
mask and the procedure is repositioned in the list.
.SH "SEE ALSO"
XtAppNextEvent(__libmansuffix__),
XtBuildEventMask(__libmansuffix__)
.br
\fI\*(xT\fP
.br
\fI\*(xL\fP
