.\" Copyright 1993 X Consortium
.\"
.\" Permission is hereby granted, free of charge, to any person obtaining
.\" a copy of this software and associated documentation files (the
.\" "Software"), to deal in the Software without restriction, including
.\" without limitation the rights to use, copy, modify, merge, publish,
.\" distribute, sublicense, and/or sell copies of the Software, and to
.\" permit persons to whom the Software is furnished to do so, subject to
.\" the following conditions:
.\"
.\" The above copyright notice and this permission notice shall be
.\" included in all copies or substantial portions of the Software.
.\"
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
.\" EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
.\" MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
.\" IN NO EVENT SHALL THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR
.\" OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
.\" ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
.\" OTHER DEALINGS IN THE SOFTWARE.
.\"
.\" Except as contained in this notice, the name of the X Consortium shall
.\" not be used in advertising or otherwise to promote the sale, use or
.\" other dealings in this Software without prior written authorization
.\" from the X Consortium.
.\"
.ds tk X Toolkit
.ds xT X Toolkit Intrinsics \- C Language Interface
.ds xI Intrinsics
.ds xW X Toolkit Athena Widgets \- C Language Interface
.ds xL Xlib \- C Language X Interface
.ds xC Inter-Client Communication Conventions Manual
.ds Rn 3
.ds Vn 2.2
.hw XtConfigure-Widget XtMove-Widget XtResize-Widget wid-get
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de ZN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH XtConfigureWidget __libmansuffix__ __xorgversion__ "XT FUNCTIONS"
.SH NAME
XtConfigureWidget, XtMoveWidget, XtResizeWidget \- move and resize widgets
.SH SYNTAX
.HP
void XtConfigureWidget(Widget \fIw\fP, Position \fIx\fP, Position \fIy\fP,
Dimension \fIwidth\fP, Dimension \fIheight\fP, Dimension \fIborder_width\fP);
.HP
void XtMoveWidget(Widget \fIw\fP, Position \fIx\fP, Position \fIy\fP);
.HP
void XtResizeWidget(Widget \fIw\fP, Dimension \fIwidth\fP, Dimension
\fIheight\fP, Dimension \fIborder_width\fP);
.HP
void XtResizeWindow(Widget \fIw\fP);
.SH ARGUMENTS
.IP \fIwidth\fP 1i
.br
.ns
.IP \fIheight\fP 1i
.br
.ns
.IP \fIborder_width\fP 1i
Specify the new widget size.
.IP \fIw\fP 1i
Specifies the widget.
.ds Nu new widget
.IP \fIx\fP 1i
.br
.ns
.IP \fIy\fP 1i
Specify the \*(Nu x and y coordinates.
.SH DESCRIPTION
The
.ZN XtConfigureWidget
function returns immediately if the specified geometry fields
are the same as the old values.
Otherwise,
.ZN XtConfigureWidget
writes the new x, y, width, height, and border_width values 
into the widget and, if the widget is realized, makes an Xlib
.ZN XConfigureWindow
call on the widget's window.
.LP
If either the new width or height is different from its old value,
.ZN XtConfigureWidget
calls the widget's resize procedure to notify it of the size change;
otherwise, it simply returns.
.LP
The
.ZN XtMoveWidget
function returns immediately if the specified geometry fields
are the same as the old values.
Otherwise,
.ZN XtMoveWidget
writes the new x and y values into the widget 
and, if the widget is realized, issues an Xlib
.ZN XMoveWindow
call on the widget's window.
.LP
The
.ZN XtResizeWidget
function returns immediately if the specified geometry fields
are the same as the old values. 
Otherwise,
.ZN XtResizeWidget
writes the new width, height, and border_width values into
the widget and, if the widget is realized, issues an
.ZN XConfigureWindow
call on the widget's window.
.LP
If the new width or height are different from the old values,
.ZN XtResizeWidget
calls the widget's resize procedure to notify it of the size change.
.LP
The
.ZN XtResizeWindow
function calls the 
.ZN XConfigureWindow
Xlib function to make the window of the specified widget match its width,
height, and border width. 
This request is done unconditionally because there is no way to tell if these
values match the current values.
Note that the widget's resize procedure is not called.
.LP
There are very few times to use
.ZN XtResizeWindow ;
instead, you should use
.ZN XtResizeWidget .
.SH "SEE ALSO"
XtMakeGeometryRequest(__libmansuffix__),
XtQueryGeometry(__libmansuffix__)
.br
\fI\*(xT\fP
.br
\fI\*(xL\fP
