.\" Copyright 1993 X Consortium
.\"
.\" Permission is hereby granted, free of charge, to any person obtaining
.\" a copy of this software and associated documentation files (the
.\" "Software"), to deal in the Software without restriction, including
.\" without limitation the rights to use, copy, modify, merge, publish,
.\" distribute, sublicense, and/or sell copies of the Software, and to
.\" permit persons to whom the Software is furnished to do so, subject to
.\" the following conditions:
.\"
.\" The above copyright notice and this permission notice shall be
.\" included in all copies or substantial portions of the Software.
.\"
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
.\" EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
.\" MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
.\" IN NO EVENT SHALL THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR
.\" OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
.\" ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
.\" OTHER DEALINGS IN THE SOFTWARE.
.\"
.\" Except as contained in this notice, the name of the X Consortium shall
.\" not be used in advertising or otherwise to promote the sale, use or
.\" other dealings in this Software without prior written authorization
.\" from the X Consortium.
.\"
.ds tk X Toolkit
.ds xT X Toolkit Intrinsics \- C Language Interface
.ds xI Intrinsics
.ds xW X Toolkit Athena Widgets \- C Language Interface
.ds xL Xlib \- C Language X Interface
.ds xC Inter-Client Communication Conventions Manual
.ds Rn 3
.ds Vn 2.2
.hw XtCallback-Popdown wid-get
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de ZN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH XtPopdown __libmansuffix__ __xorgversion__ "XT FUNCTIONS"
.SH NAME
XtPopdown, XtCallbackPopdown \- unmap a pop-up
.SH SYNTAX
.HP
void XtPopdown(Widget \fIpopup_shell\fP); 
.HP
void XtCallbackPopdown(Widget \fIw\fP, XtPointer \fIclient_data\fP, XtPointer
\fIcall_data\fP);
.HP
void MenuPopdown(String \fIshell_name\fP); 
.SH ARGUMENTS
.IP \fIcall_data\fP 1i
Specifies the callback data,
which is not used by this procedure.
.IP \fIclient_data\fP 1i
Specifies a pointer to the
.ZN XtPopdownID
structure.
.ds Ps \ to pop down
.IP \fIpopup_shell\fP 1i
Specifies the widget shell\*(Ps.
.ds Sn down
.IP \fIshell_name\fP 1i
Specifies the name of the widget shell to pop \*(Sn.
.IP \fIw\fP 1i
Specifies the widget.
.SH DESCRIPTION
The
.ZN XtPopdown
function performs the following:
.IP \(bu 5
Calls
.ZN XtCheckSubclass
.\".ZN XtCheckSubclass(popup_shell, popupShellWidgetClass)
to ensure popup_shell is a subclass of
.ZN Shell .
.IP \(bu 5
Checks that popup_shell is currently popped_up;
otherwise, it generates an error.
.IP \(bu 5
Unmaps popup_shell's window.
.IP \(bu 5
If popup_shell's grab_kind is either
.ZN XtGrabNonexclusive
or
.ZN XtGrabExclusive ,
it calls
.ZN XtRemoveGrab .
.\".ZN XtRemoveGrab(popup_shell)
.IP \(bu 5
Sets pop-up shell's popped_up field to 
.ZN False .
.IP \(bu 5
Calls the callback procedures on the shell's popdown_callback list.
.LP
The
.ZN XtCallbackPopdown
function casts the client data parameter to an
.ZN XtPopdownID
pointer:
.LP
.Ds 0
.TA .5i 3i
.ta .5i 3i
typedef struct {
	Widget shell_widget;
	Widget enable_widget;
} XtPopdownIDRec, *XtPopdownID;
.De
The shell_widget is the pop-up shell to pop down,
and the enable_widget is the widget that was used to pop it up.
.LP
.ZN XtCallbackPopdown
calls
.ZN XtPopdown
with the specified shell_widget 
and then calls
.ZN XtSetSensitive
to resensitize the enable_widget.
.LP
If a shell name is not given,
.ZN MenuPopdown
calls
.ZN XtPopdown
with the widget for which the translation is specified.
If a shell_name is specified in the translation table,
.ZN MenuPopdown
tries to find the shell by looking up the widget tree starting at the
parent of the widget in which it is invoked.
If it finds a shell with the specified name in the pop-up children 
of that parent, 
it pops down the shell; 
otherwise, it moves up the parent chain as needed.
If 
.ZN MenuPopdown 
gets to the application top-level shell widget 
and cannot find a matching shell, 
it generates an error.
.SH "SEE ALSO"
XtCreatePopupShell(__libmansuffix__),
XtPopup(__libmansuffix__)
.br
\fI\*(xT\fP
.br
\fI\*(xL\fP
